/*
 * erl_scan.h
 */

#ifndef _ERL_SCAN_H
#define _ERL_SCAN_H

typedef struct {
  char *option_name;
  char *option_value;
} erl_option;

/* Look for a properly constructed <erl ...> tag, and its corresponding
 * </erl> counterpart. begin and end will designate the < of <erl ...>
 * and the > of </erl>, while content_begin and content_end point delimit
 * the domain between those tags. 0 will be returned if no tag has
 * been found, 1 if ok. <? and ?> can be used as a short form without
 * parameters. An options array is created if parameters have been
 * found. */
int lookup_erl (const char *text, char **begin, char **end,
		char **content_begin, char **content_end,
		erl_option **options);

#endif
