-module (base64).
-export ([decode/1]).

decode ([]) -> [];
decode ([B1, B2, $=, $=]) ->
    <<V1, _V2, _V3 >> = <<(unmap (B1)):6, (unmap(B2)):6, 0:6, 0:6>>,
    [V1];
decode ([B1, B2, B3, $=]) ->
    <<V1, V2, _V3>> = <<(unmap (B1)):6, (unmap (B2)):6, (unmap (B3)):6, 0:6>>,
    [V1, V2];
decode ([B1, B2, B3, B4 | T]) ->
    <<V1, V2, V3>> = <<(unmap (B1)):6, (unmap (B2)):6, (unmap (B3)):6,
                       (unmap (B4)):6>>,
    [V1, V2, V3 | decode (T)].
    
unmap (C) when C >= $A, C =< $Z -> C - $A;
unmap (C) when C >= $a, C =< $z -> C + 26 - $a;
unmap (C) when C >= $0, C =< $9 -> C + 52 - $0;
unmap ($+) -> 62;
unmap ($/) -> 63.
